#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_h.py                                                        
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_h.py stellt Tools für die anderen absenzen-Module zur Verfügung
  Schwerpunkt: HTML-Einbettungen
________________________________________________________________________
'''

def klein_graue_null(wert,textvor='',textnach=''):
    return graue_null(wert,'<small> ('+textvor,textnach+')</small>')
    
def graue_null(wert,textvor='',textnach=''):
    if wert:
        return textvor+str(wert)+textnach
    else:
        return '<span style="color:#888">'+textvor+'0'+textnach+'</span>'

def erfolgsmeldung2html(erfolgsmeldung,mit_verlauf=True):
    ausgabe='<p title="Ergebnis der letzten Änderung" '
    if len(erfolgsmeldung)==0:      ausgabe+='style="background:white;opacity: .7;">&nbsp;</p>'
    elif erfolgsmeldung[0]=="+":
        ausgabe+='style="background:lightgreen;">' + erfolgsmeldung[1:] + '</p>\n'
        if mit_verlauf:
            import a_session
            a_session.aS.erweitere_verlauf(erfolgsmeldung[1:]) # nur Erfolge kommen in den Verlauf
    elif erfolgsmeldung[0]=="-":    ausgabe+='style="background:orange;">' + erfolgsmeldung[1:] + '</p>\n'
    elif erfolgsmeldung[0]=="*":    ausgabe+='style="background:lightgrey;">' + erfolgsmeldung[1:] + '</p>\n'
    else:                           ausgabe+='style="background:#EEE;">Info: ' + erfolgsmeldung + '</p>\n'
    return ausgabe

def einleitung():
    return('''Content-Type: text/html\n\n<!DOCTYPE html><html> \n''')

def headstart(): # Standard-head für anzuzeigende HTML-Ausgaben. Für HTML-Dateien (ohne externe Referenzen!) siehe folgende Funktion verbinde_html
    favi='<link rel="icon" href="/favicon2.ico" />' if is_development else ''
    return('''<head>
    <link rel="stylesheet" href="/a.css" type="text/css" />
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />\n
    <meta http-equiv="cache-control" content="no-cache">'''+favi)
    
def verbinde_html(head='',body='',bodyextras='',filetype='',filename='',mit_datepicker=False,mit_zielscroll=False,mit_popups=False):
    filetype=filetype.lower().strip()
    if filetype:
        if filename:
            intro='Content-Type: text/{typ}; charset=utf-8\nContent-Disposition: attachment;filename={name}\n\n'.format(typ=filetype,name=filename)
        else:
            intro='Content-Type: text/{typ}; charset=utf-8\nContent-Disposition: attachment;filename=download.{typ}\n\n'.format(typ=filetype)
        if filetype=='html':
            intro+='<!DOCTYPE html>\n<html>\n<head>\n\t<meta http-equiv="content-type" content="text/html; charset=utf-8" />\n'
    else:
        intro=einleitung()+headstart()
    if filetype in ['','html']:
        if mit_datepicker or  _mit_datepicker_:
            _sammel_header_.insert(0,_jqueryui_) 
        if mit_zielscroll or _mit_zielscroll_:
            _sammel_header_.insert(0,_zielscroll_) 
        if mit_datepicker or mit_zielscroll or _mit_datepicker_ or _mit_zielscroll_:
            _sammel_header_.insert(0,_jquery_) # davor... 
        if mit_popups:
            _sammel_header_.insert(0,_popups_) 
        intro+='\n'.join(_sammel_header_)+head+'</head>\n\n<body '+bodyextras+''.join(_sammel_bodyextras_)+'>\n'
    return intro+''.join(_sammel_body_)+body+'\n'
    
def merke_header_zeile(header):
    global _sammel_header_
    _sammel_header_.append(header+'\n')

def merke_body_extra(bodyextra):
    global _sammel_bodyextras_
    _sammel_bodyextras_.append(bodyextra)

def merke_body(body):
    global _sammel_body_
    _sammel_body_.append(body)

def merke_body_zeile(body):
    global _sammel_body_
    _sammel_body_.append(body+'\n')
    
is_development=False
_sammel_header_=[]
_sammel_body_=[]
_sammel_bodyextras_=[]
_mit_datepicker_=False
_mit_zielscroll_=False


_jquery_='''
    <script src="/js/jquery.js"></script>\n'''
_jqueryui_='''
    <script src="/js/jquery-ui/jquery-ui.js"></script>
    <link href="/js/jquery-ui/jquery-ui.css" rel="stylesheet">
    <script>
        $(function() {
            $( ".datepicker" ).datepicker({
                dateFormat: "dd.mm.yy",
                prevText: '&#x3c;zurück', prevStatus: '',
                prevJumpText: '&#x3c;&#x3c;', prevJumpStatus: '',
                nextText: 'Vor&#x3e;', nextStatus: '',
                nextJumpText: '&#x3e;&#x3e;', nextJumpStatus: '',
                currentText: 'heute', currentStatus: '',
                todayText: 'heute', todayStatus: '',
                clearText: '-', clearStatus: '',
                closeText: 'schließen', closeStatus: '',
                monthNames: ['Januar','Februar','März','April','Mai','Juni',
                    'Juli','August','September','Oktober','November','Dezember'],
                monthNamesShort: ['Jan','Feb','Mär','Apr','Mai','Jun',
                    'Jul','Aug','Sep','Okt','Nov','Dez'],
                dayNames: ['Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag'],
                dayNamesShort: ['So','Mo','Di','Mi','Do','Fr','Sa'],
                dayNamesMin: ['So','Mo','Di','Mi','Do','Fr','Sa'],
                showMonthAfterYear: false,
                showOn: 'both',
                buttonImageOnly: false
            } 
          );
        });
    </script>\n'''
    # dank http://stackoverflow.com/users/903907/muthu in Antwort bei http://stackoverflow.com/questions/14603233/jquery-datepicker-localization-german
    
_zielscroll_='  <script src="../js/a_scroll2highlight.js"></script>'
    
_popups_='''
    <script type="text/javascript">
            function popup (url) {
                fenster = window.open(url, "Popupfenster", "width=300,height=200,resizable=yes");
                fenster.focus();
                return false;
            }
            function target_popup(form) {
                fenster = window.open('', 'formpopup', 'width=600,height=450,resizeable,scrollbars');
                form.target = 'formpopup';
                fenster.focus();
            }
    </script>'''
