#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_listen_einlesen.py                                                            
 This file is free software under              
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_listen_einlesen.py liest die Listen
    - der Kurse (Q-Stufe)
    - der lehrer der Klassen (U+M) und
    - der Schüler (U+M) ein und schreibt sie in die Datenbank
________________________________________________________________________
'''

import sys
import codecs
import time, datetime
import random

import cgi
import cgitb; cgitb.enable()
import os, sys

import hashlib
import a_main, a_tool, a_upload
import a_db 

from a_konstanten import *
import a_js
import a_datum

def kurslisten_einlesen():
    importerfolg=False
    f=codecs.open(a_tool.get_datenpfad()+'kursliste.txt',mode="r",encoding='iso-8859-1')
    a_db.execute('DELETE from p2k')
    statemachine=0  # 0: Suche nach Seitenanfang - Treffer:-> 1, delta=2
                    # 1: überspringe Zeilen bis delta=0 , dec delta ->2
                    # 2: Lese Kopfzeile mit Bezeichnung, Lehrer und kbezeichnung ->3, delta=2
                    # 3: Überspringe Zeilen bis delta=0, wenn Zeile ---- enthält, dec delta ->4
                    # 4: Lese Schülernamen ein, wenn keiner mehr da ->0 (neue Seite) 
                    # 5: Wie 0, aber schaut ob es eine Fortsetzung der aktuellen Kursliste gibt
                    # 6: Wie 1, aber schaut ob es eine Fortsetzung der aktuellen Kursliste gibt
                    # immer: EOF-> Ende
                    
    kopfkennzeichen="Schuljahr:"
    zeilenzahl=0
    delta=0
    for zeile in f:
        zeilenzahl+=1
        while zeile[-1] in '\n\r' and len(zeile)>1:
            zeile=zeile[:-1]
        if debuglevel>0: a_tool.importlog("Z.Nr."+str(zeilenzahl)+",State"+str(statemachine)+",delta"+str(delta)+": "+str(zeile))
        
        if statemachine in [0,5]:
            # Suche ein Seitenanfangskennzeichen
            if kopfkennzeichen in zeile:
                statemachine+=1
                delta=3 if statemachine==1 else 0
                
        elif statemachine in [1,3]:
            # überspringe delta Zeilen
            if statemachine==1 or (zeile.find('-------')>=0) :
                delta-=1
            if delta<1:
                statemachine+=1
            
        elif statemachine==2:
            # Lese Kursdaten ein
            kbez,js=lege_kurs_an(zeile)
            statemachine=3
            delta=2 # Tabellenkopf überspringen
            
        elif statemachine in [4,6]:
            # Lese Schüler ein
            if debuglevel>=1 and statemachine==4: a_tool.importlog("Lese Schüler",zeile)
            if debuglevel>=1 and statemachine==6: a_tool.importlog("Lese evtl. Schüler",zeile)
            if statemachine==6 and zeile.strip().startswith("Sortier"):
                statemachine=1
                delta=2
            else:
                statemachine=4 # schaltet also bei Erfolg von 6 auf 4
                zeilenende=len(zeile)
                while zeilenende>0 and (zeile[zeilenende-1] in " |\n\r"):
                    zeilenende-=1
                if zeilenende>0:
                    zeile=zeile[:zeilenende]    
                    zeilenarray=zerlege_zeile(zeile)
                    nr_name=zeilenarray[0].split(" ")
                    if nr_name[0].isdigit() and len(nr_name)>=3:
                        namenarray=nr_name[1:]
                        sname=" ".join(namenarray)
                        logtxt,errtxt,pid=a_tool.schueler_eintragen(sname,kbez,js,do_commit=False)
                        if logtxt or errtxt: a_tool.importlog(logtxt,err=errtxt)
                        importerfolg=True
                    else:
                        if statemachine==4:
                            statemachine=5
                        else:
                            statemachine=1
                            delta=2
                else:
                    if statemachine==4:
                        statemachine=5
                    else:
                        statemachine=1
                        delta=2
    f.close()
    a_db.commit()
    a_db.set_config('intern_gueltiges_schuljahr',a_datum.reales_schuljahr())
    return importerfolg

def lege_kurs_an(zeile): # gibt außerdem Kursbezeichnung und js (aus 0,21-25) zurück
    if debuglevel>0: a_tool.importlog("Lese Kurs",zeile)
    zeilenarray=zerlege_zeile(zeile)
    a_tool.importlog(zeilenarray)
    klehrer='';klehrer_nr=0; kbez=" ";
    if len(zeilenarray)==3:
        kbez=zeilenarray[2].split(" ")[-1]
        kname=zeilenarray[0]
        klehrer=a_tool.entferne_titel(zeilenarray[1])
        klehrer=klehrer.strip()
    elif len(zeilenarray)==2:
        kbez=zeilenarray[1].split(" ")[-1]
        kname=a_tool.bereinige_name(zeilenarray[0],space_ok=True)
        a_tool.importlog("",err="Kein Lehrername in: "+zeile)
        klehrer="noname"
    if klehrer!="": 
        klehrer=a_tool.bereinige_name(klehrer)
        kbez=a_tool.bereinige_name(kbez)
        klehrer_nr=a_tool.lege_user_an(klehrer) # prüft natürlich erst, ob er schon da ist, liefert immer die ggf. neue user_nr zurück
        if debuglevel>0: a_tool.importlog("Neuer Kurs: ",kbez+" "+kname+" "+klehrer+" "+str(klehrer_nr))
        wotage,vlehrer_nr=0,0
        gibts_schon=False
        row_count=a_db.execute('''UPDATE kurse SET kname=? , klehrer_nr=?  WHERE kbez=?''',(kname,a_tool.get_user_nr(klehrer),kbez),do_commit=False)
        if not row_count: # uups, gab's noch nicht
            a_db.execute('''INSERT INTO kurse (kbez,kname,klehrer_nr,wochentage,vlehrer_nr) VALUES (?,?,?,?,?)''',(kbez,kname,klehrer_nr,wotage,vlehrer_nr),do_commit=False)
        
    else: a_tool.importlog(txt="",err="Probleme mit dem Zeilenarray: falsche Länge")
    if len(kbez)>0:
        js=0
        for kj in range(21,26): # Vergleich mit Berücksichtigung der Großschreibung
            if a_js.get_kj(kj).praefix and kbez.startswith(a_js.get_kj(kj).praefix):
                js=kj
        if js==0:
            for kj in range(21,26): # ohne Treffer: Vergleich mit nur Kleinbuchstaben
                if a_js.get_kj(kj).praefix and kbez.lower().startswith(a_js.get_kj(kj).praefix.lower()):
                    js=kj
        if js==0:
            a_tool.importlog('',err='Kurs '+kbez+' wird keiner Jahrgangsstufe zugeordnet - entweder jahrgangsübergreifend oder falsches Kurspraefix!')
    return kbez,js
                    
    
def zerlege_zeile(zeile):
    '''zerlegt eine zeile in eine Liste, Trenner sind die über ein Leerzeichen hinausgehenden Leerzeichensammlungen'''
    if debuglevel>2: a_tool.importlog("Zerlege:",zeile)
    tmp=zeile.strip()
    array=[]
    while "  " in tmp:
        pos=tmp.find("  ")
        array.append(tmp[:pos].strip())
        tmp=tmp[pos:].strip()
    array.append(tmp.strip())
    if debuglevel>2: a_tool.importlog("Ergibt:",str(array))
    return array


debuglevel=2
#kurs_sicherung={}
bincgi=False

if __name__ == '__main__':
    bincgi=True
    importerfolg=False
    erfolg, message=a_upload.save_uploaded_file('kursliste','kursliste.txt')
    a_tool.importlog("Kurslistenupload",message)
    if erfolg:
        if True: #try:
            a_js.hole_kj_kriterien()
            if kurslisten_einlesen():
                a_tool.importlog(a_tool.bestimme_anfangsbuchstabenverteilung())
                a_tool.importlogfinish()
                importerfolg=True
                a_main.absentmain(erfolgsmeldung='+Einlesen erfolgreich',kurspflicht='StammdatenS',fehlerliste=a_tool.get_importerrors())
        #except:
        #   pass

        
        
    if not importerfolg:
        a_tool.importlogfinish()
        a_main.absentmain('-Fehler beim Einlesen ('+a_tool.logliste[-1]+')')
