#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 ab_rufe.py                                                         
 This file is free software under          
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist  Freie Software gemäß
         der GPL ohne jegliche Garantie ist - siehe die Datei COPYING 
________________________________________________________________________

 ab_rufe.py liefert die beiden Listen der zu rufenden Schüler,
     deren fehlende Entschuldigungen in einem gewissen Intervall liegen
________________________________________________________________________
'''

from a_konstanten import *

import a_tool
import a_db
import a_js
import a_datum

import time, datetime
import base64
        
def rufe():
    stichtag_von= a_datum.heute_plus_delta_datum(-FRIST_VON_UEBERFAELLIG)
    stichtag_bis= a_datum.heute_plus_delta_datum(-FRIST_BIS_UEBERFAELLIG)
    stichtag_warn1=a_datum.heute_plus_delta_datum(-FRIST_VON_UEBERFAELLIG+7) # warnt eine Woche vorher rot, flashend
    stichtag_warn2=a_datum.heute_plus_delta_datum(-FRIST_VON_UEBERFAELLIG+14) # warnt zwei Wochen vorher orange
    skelett='''<div class="content"><table cellspacing="5"><tr>
    <td nobord="true"><h4>Fehlende Entschuldigungen bzw. Atteste klären!</h4>
    <p>{namen}<small><small> (absenzenverwaltung)</small></small></p>
    </td></tr></table>\n</div>'''
        
    ## Nach überfälligen, aber noch lieferbaren Entschuldigungen

    namenliste=[] # Ein Array mit 6 Strings
    #print(namenliste)
    for kj in range(1,6):
        qzeile=[]
        for pid,name,apdatum,mindate in a_db.get_rowdict_list('''
                 SELECT personen.pid,name,apdatum,min(datum)
                 FROM   personen,absenzen 
                 WHERE  personen.pid=absenzen.pid AND status>=? AND status<? 
                    AND attestpflicht=0 AND (apdatum<"2012-00-00" OR apdatum>absenzen.datum )
                    AND js = ? 
                    AND datum BETWEEN ? AND ?
                 GROUP BY name 
                 ORDER BY name''',(LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG,20+kj,stichtag_von,stichtag_bis)):
            if mindate<=stichtag_warn1:
                pre,small,post='<span class="s_t_fresh">','<small class="s_t_fresh">&nbsp;','</span>'
            elif mindate<=stichtag_warn2:
                pre,small,post='<span style="color:brown">','<small style="color:brown">&nbsp;','</span>'
            else:
                pre,small,post='','<small>&nbsp;',''
            namegeteilt=name.split(' ')            
            qzeile.append(pre+namegeteilt[0]+small+'&nbsp;'.join(namegeteilt[1:])+'</small>'+post)
        namenliste.append(skelett.format(namen=', '.join(qzeile)))
        
    #print(namenliste)
  
    return namenliste

def u_b_a(codeme):
    #utf_2_b64_2_ascii
    return base64.encodestring(codeme.encode("utf-8")).decode('ascii')
    
#######################################################
#######################################################
# Alles startet hier...

if __name__ == '__main__':
    print('''Content-Type: text/html\n\n<!DOCTYPE html><html>
    <body><h1>Datenuebertragung</h1>\n''')
    listen=rufe()
    resultat=[]
    for l in listen:
        resultat.append(u_b_a(l))
    dfue='*QTrenner*\n'+'\n*QTrenner*\n'.join(resultat)+'\n*QTrenner*'
    print(dfue)
    print('\n</body></html>')
